///Common object used by front and back end service
///which represents a user
class User {
  late int userID;
  String? googleUserID;
  String? givenName;
  String? familyName;
  String? email;
  String? password;
  bool? handicapped;

  User(
      {this.userID = -1,
      required this.googleUserID,
      required this.givenName,
      required this.familyName,
      required this.email,
      this.password = 'unset',
      required this.handicapped});

  User.fromJson({required Map json}) {
    userID = json['userID'];
    googleUserID = json['googleUserID'];
    givenName = json['givenName'];
    familyName = json['familyName'];
    email = json['email'];
    password = json['password'];
    handicapped = json['handicapped'];
  }

  Map toJson() {
    final map = {
      'userID': userID,
      'googleUserID': googleUserID,
      'givenName': givenName,
      'familyName': familyName,
      'email': email,
      'password': password,
      'handicapped': handicapped
    };
    return map;
  }

  User.fromDBObj({required var userBinary}) {
    userID = userBinary.fields['userID'];
    googleUserID = userBinary.fields['googleUserID'];
    givenName = userBinary.fields['givenName'];
    familyName = userBinary.fields['familyName'];
    email = userBinary.fields['email'];
    password = userBinary.fields['password'];
    handicapped = _fromTinyInt(tinyInt: userBinary.fields['handicapped']);
  }

  bool _fromTinyInt({required int tinyInt}) {
    if (tinyInt == 1) {
      return true;
    } else {
      return false;
    }
  }
}
