import 'package:smart_parking_solutions_common/src/core_objects/parking_space.dart';

class SearchSpacesResponse {
  SearchSpacesResponse(
      {required this.distance,
      required this.space,
      required this.humanAddress,
      required this.description});

  SearchSpacesResponse.fromJson({required Map json}) {
    distance = json['distance'];
    space = ParkingSpace.fromJson(json: json['space']);
    humanAddress = json['human_address'];
    description = json['description'] as Map;
  }

  late String distance;
  late String humanAddress;
  late Map description;
  late ParkingSpace space;

  Map toJson() {
    final map = {
      'distance': distance,
      'human_address': humanAddress,
      'space': space.toJson(),
      'description': description
    };
    return map;
  }
}
